#include <vo_stdio.h>
#include <vo_fat.h>
#include <vs1010dRom.h>
#include <volink.h>
#include "fatdirectory.h"


#define DIR_CACHE_ENTRIES 750
// Entries in Y:
// - directory cache (permananet) dirc
// - file name buffer (temporary) fileNameStash
typedef __y struct {
	u_int16 firstSongNumber; //0 for unallocated entry, 1 is first playable song.
	u_int32 dirStartCluster;
} DirCacheEntry;


typedef struct {
	__y DirCacheEntry *cur; //The directory we're in.
	int n; ///< Number of directory cache entries currently populated
	int total; ///< Total number of directory cache entries for which memory is allocated.
	u_int16 nextSongNumber; ///< used for indexing
	u_int16 nowPlaying; ///< used by player routine
	u_int16 totalSongs; ///< used by player routine
	DirCacheEntry e[DIR_CACHE_ENTRIES];
} DirCache;


#ifdef ARCSTRUCT_H
DLLIMPORT(dirc) extern __y DirCache dirc; //dllimport extern in arc project, allocated in bigarc loader
#else
extern __y DirCache dirc;
#endif


#define DIR_LIST_ENTRIES 750

// Entries in X:
// - directory sort list (temporary) dirs
typedef struct {
	__y char *dirName;
	u_int32 dirStartCluster;
} DirNameAndCluster;
extern __x DirNameAndCluster dirs[DIR_LIST_ENTRIES];
extern DirNameAndCluster *dirListTop;

extern __y char fileNameStash[9000];
extern __y char *fnsp;// = fileNameStash;


void PrintDirectoryCache();
void PrintDirectorySortArray(); 
int ReadAndSortDirectoryFile(FILE *f, DirNameAndCluster *dirListBuffer);
u_int16 ReadAndSortDirectoryCluster(u_int32 dirStartCluster, DirNameAndCluster *dirListBuffer);
//int InsertSortListToCache(DirNameAndCluster *bottom, DirNameAndCluster *top);
int InsertSortListToCache(DirNameAndCluster *bottom, int numberOfDirectories);
void DirCacheInit();
void AddSongToSortList(DirectoryEntry *de);
void BuildDirectoryCache();

int FirstSongOfNextAlbum(u_int16 songNumber);

int CompareByDirectoryName(DirNameAndCluster *a, DirNameAndCluster *b) ;

void PrintSpaces(int n);
void PrintYString(__y char *s);

