#include "lcdui.h"
//#include "arcstruct.h"
//#include "rcrx2.h"
#include <lcd.h>
#include <rgb565.h>
#include <vs1010dRom.h>
#include <voaudio.h>
#include <vo_gpio.h>
#include <string.h>
#include "fatdircache.h"


const char *iecAudioTypeString[] = {	
	"NO","AC3","2","PAUSE","MP1","MP23","MPG","AAC", //0x00..0x07
	"MP1","MP2","MP3","DTS","DTS2","DTS3","ATRAC","ATRAC3", //0x08..0x0F
	"ATRACX","DTSHD","WMA","AAC","14","EAC3","TRUEHD" //0x10..0x16
};


const char *AudioFmtStr(s_int16 n) {
	if (n==-1) return "PCM";
	if (n<0x17) return iecAudioTypeString[n];
	return "unknown";
}

u_int16 suppressLcdPrints = 0;


#define __LCD_PIN_A0 (lcd0.pinA0CS >> 8)
#define __LCD_PIN_CS (lcd0.pinA0CS & 0xff)
#define __LCD_PIN_WR 0x2a

#define LCD_BACKGROUND_STRIPE_COLOR 0xfffe

#define LCD_SET_COMMAND_MODE() {GpioSetPin(__LCD_PIN_A0, 0);}
#define LCD_SET_DATA_MODE() {GpioSetPin(__LCD_PIN_A0, 1);}
#define	LCD_START_FRAME() {GpioSetPin(__LCD_PIN_CS, 0);}
#define	LCD_END_FRAME(){GpioSetPin(__LCD_PIN_CS, 1);}







#define __LCD_PIN_RESET 0x07
#define LcdDelay DelayL
u_int16 MyLcdInit(u_int16 madctl) { //0xA0 for old LCD, 0xA8 for new LCD

	static char s[10];
	static u_int16 buf[120]={0};
	u_int16 i,j;
	
	//InitSpi0Taas();

	memset (&lcd0,0,sizeof(lcd0));
	lcd0.textColor = COLOR_WHITE;
	lcd0.backgroundColor = 0xfffe;
	lcd0.bkStripePtr = lcdBlueGradient;
	lcd0.width = 160;
	lcd0.height = 128;
	lcd0.pinA0CS = 0x1c1d;
	lcd0.clipx2 = 159;
	lcd0.clipy2 = 127;
	
	GpioSetPin(__LCD_PIN_A0,1);
	GpioSetPin(__LCD_PIN_CS,1);
	GpioSetPin(__LCD_PIN_RESET,0);
	LcdDelay(1000);
	GpioSetPin(__LCD_PIN_RESET,1);
	LcdDelay(1000);

	LcdStartCommand(LCD_SWRESET);
	LcdStartCommand(LCD_SWRESET);
	LcdDelay(10000);
	LcdStartCommand(LCD_SLPOUT);
	LcdDelay(10000);
	LcdStartCommand(LCD_DISPON);
	LcdDelay(10000);
	LcdStartCommand(LCD_COLMOD);
	LcdPutOctet(LCD_PIXEL_FORMAT_16BPP);
	LcdStartCommand(LCD_MADCTL);
	LcdPutOctet(madctl);
	LcdStartCommand(LCD_GASET);
	LcdPutOctet(4);
	LCD_END_FRAME();

}

