
#include <vo_stdio.h>
#include <vs1010c.h>
#include "rtcread.h"

void StartAndWaitRtcReady(register u_int16 rtcCfBits) {
	PERIP(RTC_CF) = rtcCfBits;
	while (PERIP(RTC_CF));
}

u_int32 rtcShifter;


void WriteShifter(u_int32 data) {

	PERIP(RTC_HIGH) = 0;
 	StartAndWaitRtcReady(RTC_CF_IBUSY);

	PERIP(RTC_HIGH) = (u_int16)(data >> 16);
	PERIP(RTC_LOW) = (u_int16)data;
	StartAndWaitRtcReady(RTC_CF_DBUSY);
}

u_int32 ReadShifter() {

	u_int32 shifter;

	StartAndWaitRtcReady(RTC_CF_RDBUSY);
	
	shifter = (((u_int32)PERIP(RTC_HIGH)) << 16) | (u_int32)PERIP(RTC_LOW); 
	WriteShifter(shifter);
	
	return shifter;
}

