#include <vs1010c.h>
void SRCInterruptForToslink(void); /* Prototype for the interrupt handler. */
void SetPLL(u_int16 n);

void ToslinkInit(void) {
#define CLKX 5 /* use 5.0x core clock */
	SetPLL(CLKX); /* Make sure the core clock matches our SPDIF configuration setting. */
	
	PERIP(SRC_CF)=0; /*Stop SRC*/
	PERIP(SP_TX_CF) = 0; /*Stop Transmitter*/
	PERIP(GPIO1_MODE) |= GPIO1_SPDIF_OUT; //(1<<14)
	WriteToProgramRam(0x20+INTV_SRC, ReadFromProgramRam((u_int16)SRCInterruptForToslink-1));
	/* SPDIF channel status bits */
	PERIP(SP_TX_CHST0) = 1*SP_TX_CHST0_CP; //No copyright
	PERIP(SP_TX_CHST1) =
		0*SP_TX_CHST1_CLKA //29:28 - "00" 0.1%, "10" - variable pitch
		|1*SP_TX_CHST1_FS  //27:24 - Indicated rate - "0001": rate not indicated
		//|3*SP_TX_CHST1_CH  //23:20 - "0011" sub1:no chnum, sub2:no chnum
 		//|0*SP_TX_CHST1_CH  //23:20 - "0000" sub1:no chnum, sub2:no chnum
		|9*SP_TX_CHST1_CH  //23:20 - "1001" sub1:left, sub2:right
		|0*SP_TX_CHST1_SRC //19:16 - source number
	;
	/* Enable STX and SRC as in-sync as possible. To make sure you could Disable()/Enable() */
	//PERIP(SP_TX_CHST2) = 4*SP_TX_CHST2_CH2_WRDL | SP_TX_CHST2_TX_ENA;
	PERIP(SP_TX_CHST2) =
		0*SP_TX_CHST2_CH2_FSO      //original rate "0000"=not indicated
		| 5*SP_TX_CHST2_CH2_WRDL   //35:33 "101"=24/20bits
		| SP_TX_CHST2_CH2_WRDLM  //32 max sample word length 1=24bits
		| SP_TX_CHST2_TX_ENA;    //Transmitter enable
#if 0
	PERIP(SP_TX_CF) = CLKX*SP_TX_CF_CLKDIV | SP_TX_CF_IE | SP_TX_CF_SND; //96k CLKX=core clock
	PERIP(SRC_CF)=SRC_CF_ENA|SRC_CF_FS*(64-1); //96k
#else
	PERIP(SP_TX_CF) = 2*CLKX*SP_TX_CF_CLKDIV | SP_TX_CF_IE | SP_TX_CF_SND; //48k CLKX=core clock
	PERIP(SRC_CF)=SRC_CF_ENA|SRC_CF_FS*(128-1); //48k
#endif
	PERIP(INT_ENABLE1_HP)|=INTF1_SRC;
}