#define GPIO_PIN_USB_DETECT 9
#define GPIO_PIN_SDCARD_OFF 8
#define GPIO_PIN_USB_ACTIVITY 7
#define HDATCHECK 800 /* 21words: give up after 800/2=400kB ~ 3-6sec */

#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_SD_CS  2
#define SPI_MOSI  1 /* DREQ */
#define SPI_READ  0x03

#define LOUDNESS_MIN_VALUE 0x0310
#define LOUDNESS_MEDIUM_VALUE 0x25B6
#define LOUDNESS_HIGH_VALUE 0x74FF

//#define CTRL3_UPDATE_VOL        (1<<15)
#define CTRL3_BY_NAME           (1<<8) /*locate by name*/
#define CTRL3_RECORD_ON         (1<<7)
#define CTRL3_AT_END            (1<<6)
#define CTRL3_NO_NUMFILES       (1<<5)
#define CTRL3_PAUSE_ON          (1<<4)
#define CTRL3_FILE_READY        (1<<3)
#define CTRL3_PLAY_MODE_MASK    (3<<1)
#define CTRL3_PAUSE_AFTER_PLAY  (3<<1)
#define CTRL3_PAUSE_BEFORE_PLAY (2<<1)
#define CTRL3_LOOP_SONG         (1<<1)
#define CTRL3_PLAY_NEXT         (0<<1)
#define CTRL3_RANDOM_PLAY       (1<<0) /* SCI_AICTRL3 */

#define LCD_GPIO_PIN_A0 4
#define LCD_GPIO_PIN_CS 5

#define SCREEN_SET_COMMAND_MODE USEX(GPIO_ODATA) &= ~(1 << LCD_GPIO_PIN_A0);
#define SCREEN_SET_DATA_MODE USEX(GPIO_ODATA) |= (1 << LCD_GPIO_PIN_A0);

#define SCREEN_END USEX(GPIO_ODATA) |= (1 << LCD_GPIO_PIN_CS);
#define SCREEN_SELECT USEX(GPIO_ODATA) &= ~(1 << LCD_GPIO_PIN_CS);


#define SYMBOL_SPACE 32
#define SYMBOL_NUMBER 48
#define SYMBOL_ALPHA 65
#define SYMBOL_ALPHA_LOW 97 
#define SYMBOL_LEFTSPK 128
#define SYMBOL_RIGHTSPK 129
#define SYMBOL_USB 130
#define SYMBOL_DISKDRIVE 131
#define SYMBOL_PU 132
#define SYMBOL_KATAKANA 133
#define SYMBOL_DIGIT 197
#define SYMBOL_NOTE 207
#define SYMBOL_PLAY 208
#define SYMBOL_PAUSE 209
#define SYMBOL_STOP 210


#define xMin 0
#define SPI_WREN  0x06
#define SPI_WRDI  0x04
#define SPI_RDSR  0x05
#define SPI_WRSR  0x01
#define SPI_READ  0x03
#define SPI_WRITE 0x02

#define SW1 1
#define SW2 2
#define SW3 3
#define SW4 4
#define SW5 5
#define SW6 6
#define SW7 7
#define SW8 8
    
#define SW_HOME SW1
#define SW_PREV SW2
#define SW_STOP SW3
#define SW_VOL_UP SW4
#define SW_VOL_DN SW5
#define SW_REC SW6
#define SW_NEXT SW7
#define SW_PLAY SW8
#define SW_OK SW_PLAY
#define SW_NO SW_STOP
#define SW_UP SW_VOL_MORE
#define SW_DOWN SW_VOL_LESS
#define SW_LEFT SW_PREV
#define SW_RIGHT SW_NEXT
#define SW_HOLD SW_STOP
#define SW_MODE SW_STOP
#define PROTOBOARD_SW1 9
#define PROTOBOARD_SW2 10
#define PROTOBOARD_SW3 11

// For historical reasons (same PCB is also used for VS1011 and VS1003), the button
// connections in the prototyping board need to be read in a special way:
#define XDCS_PIN (1 << 11) /* button 1 is at xDCS pin */
#define SI_PIN (1 << 10) /* button 2 is at SI pin and via diode D4 also in xDCS pin */
#define BUTTON_1_PRESSED ((GPIO_IS_LOW(XDCS_PIN)) && (GPIO_IS_HIGH(SI_PIN)))
#define BUTTON_2_PRESSED (GPIO_IS_LOW(SI_PIN))
// (button 3 is more difficult to read in the prototyping board, see schematic.)


  //#define SW4 0x4000U
      
#define REWIND_STEP_SIZE 128

