#ifndef STANDALONE_H
#define STANDALONE_H

#define STANDALONE

#define USE_HC

#ifdef VS1053
#include <vsmpg.h>
#include <vs1053.h>
#include <common.h>
#include <asmfuncs.h>
#include <parametric.h>
#endif

#include <vstypes.h>
auto s_int16 myrand(void); /* output 0..0x3fff */
extern __y s_int16 rand_seed;

#include "fat.h"

#ifdef USE_HC
extern s_int16 hcShift;
#endif

void SpiLoad(register __i2 short startAddr);

void MyReset();

auto void SpiSendClocks(void);
auto u_int16 SpiSendReceiveMmc(register __a0 u_int16 topAlignedData,
			       register __a1 numBits);
auto u_int16 MmcCommand(register __b0 s_int16 cmd, register __d u_int32 arg);
auto void ReadDiskSector(register __a u_int32 sector);
auto void WritePhysicalSectorY(register __d u_int32 sector,
			      register __i3 __y u_int16 *dataBufPtr);
auto void WritePhysicalSectorYSwap(register __d u_int32 sector,
			      register __i3 __y u_int16 *dataBufPtr);
auto u_int16 GetByte(register __c0 u_int16 n);
auto u_int16 GetWord(register __c0 u_int16 n);
auto u_int32 GetLong(register __c0 u_int16 n);
auto u_int16 InitFileSystem(void);
auto u_int16 InitFileSystemR(void);
auto __y struct FRAGMENT *FragmentList(register __i2 __y struct FRAGMENT *frag,
			  register __b u_int32 fatCluster);
auto s_int16 HandleDir(register __i2 __y struct FRAGMENT *curFragment,
		       __y struct FRAGMENT *nextFragment);
auto s_int16 OpenFile(register __c0 u_int16 fileNum);
auto s_int16 CheckFileType(register __a u_int32 name);
auto s_int16 CheckFileType1003(register __a u_int32 name);
auto s_int16 CheckFileType1003Nw(register __a u_int32 name);
auto s_int16 CheckFileType1023(register __a u_int32 name);
auto s_int16 CheckFileType1033(register __a u_int32 name);
auto s_int16 CheckFileType1053(register __a u_int32 name);
auto s_int16 CheckFileType1103(register __a u_int32 name);

s_int16 RecordMode(void);
u_int16 SciModeOr(void);

extern u_int16 created[3]; /*create date, time, 100ths */

int UartFill(void);
int UartGetByte(void);
int UartPeekByte(void);

u_int16 Shuffle(register __c0 u_int16 files, register __c1 u_int16 old);

extern __y u_int16 fileName[6];
extern volatile s_int16 *srcWp, *srcRp;
extern __y u_int16 g_dcthi[2048];
void putch(register __a0 int ch);
auto void play_frame(void);
extern __y s_int16 mallocAreaY[9216];
extern __y u_int16 hwSampleRate;
s_int16 ApplAddrButRef (register __i0 s_int16 **d, register __a1 s_int16 mode,
												register __a0 s_int16 n);

#ifdef VS1053
void NewSinTest(void);
auto int PatchFrame(void);
#endif

s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode, register __a0 s_int16 n);
s_int16 ApplAddrButRef(register __i0 s_int16 **d, register __a1 s_int16 mode, register __a0 s_int16 n);
s_int16 ApplAddrSci(register __i0 s_int16 **d, register __a1 s_int16 mode, register __a0 s_int16 n);
s_int16 ApplAddrRef(register __i0 s_int16 **d, register __a1 s_int16 mode, register __a0 s_int16 n);


#endif/*STANDALONE_H*/
